From 1648cf294cb4705a05d1c1ab7795be9bd5526503 Mon Sep 17 00:00:00 2001
From: Nathan Bossart <nathan@postgresql.org>
Date: Thu, 29 Jan 2026 16:09:46 -0600
Subject: [PATCH v2 1/1] move partitioning code out of tablecmds.c

---
 src/backend/commands/Makefile              |    1 +
 src/backend/commands/meson.build           |    1 +
 src/backend/commands/tablecmds.c           | 4787 +-------------------
 src/backend/commands/tablecmds_partition.c | 4627 +++++++++++++++++++
 src/backend/partitioning/partbounds.c      |    1 +
 src/include/commands/tablecmds.h           |    2 -
 src/include/commands/tablecmds_internal.h  |  183 +
 src/include/commands/tablecmds_partition.h |   59 +
 8 files changed, 4885 insertions(+), 4776 deletions(-)
 create mode 100644 src/backend/commands/tablecmds_partition.c
 create mode 100644 src/include/commands/tablecmds_internal.h
 create mode 100644 src/include/commands/tablecmds_partition.h

diff --git a/src/backend/commands/Makefile b/src/backend/commands/Makefile
index 64cb6278409..764f75f6b52 100644
--- a/src/backend/commands/Makefile
+++ b/src/backend/commands/Makefile
@@ -57,6 +57,7 @@ OBJS = \
 	statscmds.o \
 	subscriptioncmds.o \
 	tablecmds.o \
+	tablecmds_partition.o \
 	tablespace.o \
 	trigger.o \
 	tsearchcmds.o \
diff --git a/src/backend/commands/meson.build b/src/backend/commands/meson.build
index ca3f53c6213..86b9d8780fd 100644
--- a/src/backend/commands/meson.build
+++ b/src/backend/commands/meson.build
@@ -45,6 +45,7 @@ backend_sources += files(
   'statscmds.c',
   'subscriptioncmds.c',
   'tablecmds.c',
+  'tablecmds_partition.c',
   'tablespace.c',
   'trigger.c',
   'tsearchcmds.c',
diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index f976c0e5c7e..4abba13a5b8 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -62,6 +62,8 @@
 #include "commands/event_trigger.h"
 #include "commands/sequence.h"
 #include "commands/tablecmds.h"
+#include "commands/tablecmds_internal.h"
+#include "commands/tablecmds_partition.h"
 #include "commands/tablespace.h"
 #include "commands/trigger.h"
 #include "commands/typecmds.h"
@@ -131,115 +133,6 @@ typedef struct OnCommitItem
 
 static List *on_commits = NIL;
 
-
-/*
- * State information for ALTER TABLE
- *
- * The pending-work queue for an ALTER TABLE is a List of AlteredTableInfo
- * structs, one for each table modified by the operation (the named table
- * plus any child tables that are affected).  We save lists of subcommands
- * to apply to this table (possibly modified by parse transformation steps);
- * these lists will be executed in Phase 2.  If a Phase 3 step is needed,
- * necessary information is stored in the constraints and newvals lists.
- *
- * Phase 2 is divided into multiple passes; subcommands are executed in
- * a pass determined by subcommand type.
- */
-
-typedef enum AlterTablePass
-{
-	AT_PASS_UNSET = -1,			/* UNSET will cause ERROR */
-	AT_PASS_DROP,				/* DROP (all flavors) */
-	AT_PASS_ALTER_TYPE,			/* ALTER COLUMN TYPE */
-	AT_PASS_ADD_COL,			/* ADD COLUMN */
-	AT_PASS_SET_EXPRESSION,		/* ALTER SET EXPRESSION */
-	AT_PASS_OLD_INDEX,			/* re-add existing indexes */
-	AT_PASS_OLD_CONSTR,			/* re-add existing constraints */
-	/* We could support a RENAME COLUMN pass here, but not currently used */
-	AT_PASS_ADD_CONSTR,			/* ADD constraints (initial examination) */
-	AT_PASS_COL_ATTRS,			/* set column attributes, eg NOT NULL */
-	AT_PASS_ADD_INDEXCONSTR,	/* ADD index-based constraints */
-	AT_PASS_ADD_INDEX,			/* ADD indexes */
-	AT_PASS_ADD_OTHERCONSTR,	/* ADD other constraints, defaults */
-	AT_PASS_MISC,				/* other stuff */
-} AlterTablePass;
-
-#define AT_NUM_PASSES			(AT_PASS_MISC + 1)
-
-typedef struct AlteredTableInfo
-{
-	/* Information saved before any work commences: */
-	Oid			relid;			/* Relation to work on */
-	char		relkind;		/* Its relkind */
-	TupleDesc	oldDesc;		/* Pre-modification tuple descriptor */
-
-	/*
-	 * Transiently set during Phase 2, normally set to NULL.
-	 *
-	 * ATRewriteCatalogs sets this when it starts, and closes when ATExecCmd
-	 * returns control.  This can be exploited by ATExecCmd subroutines to
-	 * close/reopen across transaction boundaries.
-	 */
-	Relation	rel;
-
-	/* Information saved by Phase 1 for Phase 2: */
-	List	   *subcmds[AT_NUM_PASSES]; /* Lists of AlterTableCmd */
-	/* Information saved by Phases 1/2 for Phase 3: */
-	List	   *constraints;	/* List of NewConstraint */
-	List	   *newvals;		/* List of NewColumnValue */
-	List	   *afterStmts;		/* List of utility command parsetrees */
-	bool		verify_new_notnull; /* T if we should recheck NOT NULL */
-	int			rewrite;		/* Reason for forced rewrite, if any */
-	bool		chgAccessMethod;	/* T if SET ACCESS METHOD is used */
-	Oid			newAccessMethod;	/* new access method; 0 means no change,
-									 * if above is true */
-	Oid			newTableSpace;	/* new tablespace; 0 means no change */
-	bool		chgPersistence; /* T if SET LOGGED/UNLOGGED is used */
-	char		newrelpersistence;	/* if above is true */
-	Expr	   *partition_constraint;	/* for attach partition validation */
-	/* true, if validating default due to some other attach/detach */
-	bool		validate_default;
-	/* Objects to rebuild after completing ALTER TYPE operations */
-	List	   *changedConstraintOids;	/* OIDs of constraints to rebuild */
-	List	   *changedConstraintDefs;	/* string definitions of same */
-	List	   *changedIndexOids;	/* OIDs of indexes to rebuild */
-	List	   *changedIndexDefs;	/* string definitions of same */
-	char	   *replicaIdentityIndex;	/* index to reset as REPLICA IDENTITY */
-	char	   *clusterOnIndex; /* index to use for CLUSTER */
-	List	   *changedStatisticsOids;	/* OIDs of statistics to rebuild */
-	List	   *changedStatisticsDefs;	/* string definitions of same */
-} AlteredTableInfo;
-
-/* Struct describing one new constraint to check in Phase 3 scan */
-/* Note: new not-null constraints are handled elsewhere */
-typedef struct NewConstraint
-{
-	char	   *name;			/* Constraint name, or NULL if none */
-	ConstrType	contype;		/* CHECK or FOREIGN */
-	Oid			refrelid;		/* PK rel, if FOREIGN */
-	Oid			refindid;		/* OID of PK's index, if FOREIGN */
-	bool		conwithperiod;	/* Whether the new FOREIGN KEY uses PERIOD */
-	Oid			conid;			/* OID of pg_constraint entry, if FOREIGN */
-	Node	   *qual;			/* Check expr or CONSTR_FOREIGN Constraint */
-	ExprState  *qualstate;		/* Execution state for CHECK expr */
-} NewConstraint;
-
-/*
- * Struct describing one new column value that needs to be computed during
- * Phase 3 copy (this could be either a new column with a non-null default, or
- * a column that we're changing the type of).  Columns without such an entry
- * are just copied from the old table during ATRewriteTable.  Note that the
- * expr is an expression over *old* table values, except when is_generated
- * is true; then it is an expression over columns of the *new* tuple.
- */
-typedef struct NewColumnValue
-{
-	AttrNumber	attnum;			/* which column */
-	Expr	   *expr;			/* expression to compute */
-	ExprState  *exprstate;		/* execution state */
-	bool		is_generated;	/* is it a GENERATED expression? */
-} NewColumnValue;
-
 /*
  * Error-reporting support for RemoveRelations
  */
@@ -325,17 +218,6 @@ struct DropRelationCallbackState
 	char		actual_relpersistence;
 };
 
-/* Alter table target-type flags for ATSimplePermissions */
-#define		ATT_TABLE				0x0001
-#define		ATT_VIEW				0x0002
-#define		ATT_MATVIEW				0x0004
-#define		ATT_INDEX				0x0008
-#define		ATT_COMPOSITE_TYPE		0x0010
-#define		ATT_FOREIGN_TABLE		0x0020
-#define		ATT_PARTITIONED_INDEX	0x0040
-#define		ATT_SEQUENCE			0x0080
-#define		ATT_PARTITIONED_TABLE	0x0100
-
 /*
  * ForeignTruncateInfo
  *
@@ -350,14 +232,6 @@ typedef struct ForeignTruncateInfo
 	List	   *rels;
 } ForeignTruncateInfo;
 
-/* Partial or complete FK creation in addFkConstraint() */
-typedef enum addFkConstraintSides
-{
-	addFkReferencedSide,
-	addFkReferencingSide,
-	addFkBothSides,
-} addFkConstraintSides;
-
 /*
  * Partition tables are expected to be dropped when the parent partitioned
  * table gets dropped. Hence for partitioning we use AUTO dependency.
@@ -431,8 +305,6 @@ static void AlterConstrUpdateConstraintEntry(ATAlterConstraint *cmdcon, Relation
 static ObjectAddress ATExecValidateConstraint(List **wqueue,
 											  Relation rel, char *constrName,
 											  bool recurse, bool recursing, LOCKMODE lockmode);
-static void QueueFKConstraintValidation(List **wqueue, Relation conrel, Relation fkrel,
-										Oid pkrelid, HeapTuple contuple, LOCKMODE lockmode);
 static void QueueCheckConstraintValidation(List **wqueue, Relation conrel, Relation rel,
 										   char *constrName, HeapTuple contuple,
 										   bool recurse, bool recursing, LOCKMODE lockmode);
@@ -455,7 +327,6 @@ static CoercionPathType findFkeyCast(Oid targetTypeId, Oid sourceTypeId,
 static void validateForeignKeyConstraint(char *conname,
 										 Relation rel, Relation pkrel,
 										 Oid pkindOid, Oid constraintOid, bool hasperiod);
-static void CheckAlterTableIsSafe(Relation rel);
 static void ATController(AlterTableStmt *parsetree,
 						 Relation rel, List *cmds, bool recurse, LOCKMODE lockmode,
 						 AlterTableUtilityContext *context);
@@ -476,12 +347,9 @@ static void ATRewriteTables(AlterTableStmt *parsetree,
 							List **wqueue, LOCKMODE lockmode,
 							AlterTableUtilityContext *context);
 static void ATRewriteTable(AlteredTableInfo *tab, Oid OIDNewHeap);
-static AlteredTableInfo *ATGetQueueEntry(List **wqueue, Relation rel);
-static void ATSimplePermissions(AlterTableType cmdtype, Relation rel, int allowed_targets);
 static void ATSimpleRecursion(List **wqueue, Relation rel,
 							  AlterTableCmd *cmd, bool recurse, LOCKMODE lockmode,
 							  AlterTableUtilityContext *context);
-static void ATCheckPartitionsNotInUse(Relation rel, LOCKMODE lockmode);
 static void ATTypedTableRecursion(List **wqueue, Relation rel, AlterTableCmd *cmd,
 								  LOCKMODE lockmode,
 								  AlterTableUtilityContext *context);
@@ -508,8 +376,6 @@ static ObjectAddress ATExecSetNotNull(List **wqueue, Relation rel,
 									  bool recurse, bool recursing,
 									  LOCKMODE lockmode);
 static bool NotNullImpliedByRelConstraints(Relation rel, Form_pg_attribute attr);
-static bool ConstraintImpliedByRelConstraint(Relation scanrel,
-											 List *testConstraint, List *provenConstraint);
 static ObjectAddress ATExecColumnDefault(Relation rel, const char *colName,
 										 Node *newDefault, LOCKMODE lockmode);
 static ObjectAddress ATExecCookedColumnDefault(Relation rel, AttrNumber attnum,
@@ -518,8 +384,6 @@ static ObjectAddress ATExecAddIdentity(Relation rel, const char *colName,
 									   Node *def, LOCKMODE lockmode, bool recurse, bool recursing);
 static ObjectAddress ATExecSetIdentity(Relation rel, const char *colName,
 									   Node *def, LOCKMODE lockmode, bool recurse, bool recursing);
-static ObjectAddress ATExecDropIdentity(Relation rel, const char *colName, bool missing_ok, LOCKMODE lockmode,
-										bool recurse, bool recursing);
 static ObjectAddress ATExecSetExpression(AlteredTableInfo *tab, Relation rel, const char *colName,
 										 Node *newExpr, LOCKMODE lockmode);
 static void ATPrepDropExpression(Relation rel, AlterTableCmd *cmd, bool recurse, bool recursing, LOCKMODE lockmode);
@@ -565,37 +429,6 @@ static ObjectAddress ATAddForeignKeyConstraint(List **wqueue, AlteredTableInfo *
 static int	validateFkOnDeleteSetColumns(int numfks, const int16 *fkattnums,
 										 int numfksetcols, int16 *fksetcolsattnums,
 										 List *fksetcols);
-static ObjectAddress addFkConstraint(addFkConstraintSides fkside,
-									 char *constraintname,
-									 Constraint *fkconstraint, Relation rel,
-									 Relation pkrel, Oid indexOid,
-									 Oid parentConstr,
-									 int numfks, int16 *pkattnum, int16 *fkattnum,
-									 Oid *pfeqoperators, Oid *ppeqoperators,
-									 Oid *ffeqoperators, int numfkdelsetcols,
-									 int16 *fkdelsetcols, bool is_internal,
-									 bool with_period);
-static void addFkRecurseReferenced(Constraint *fkconstraint,
-								   Relation rel, Relation pkrel, Oid indexOid, Oid parentConstr,
-								   int numfks, int16 *pkattnum, int16 *fkattnum,
-								   Oid *pfeqoperators, Oid *ppeqoperators, Oid *ffeqoperators,
-								   int numfkdelsetcols, int16 *fkdelsetcols,
-								   bool old_check_ok,
-								   Oid parentDelTrigger, Oid parentUpdTrigger,
-								   bool with_period);
-static void addFkRecurseReferencing(List **wqueue, Constraint *fkconstraint,
-									Relation rel, Relation pkrel, Oid indexOid, Oid parentConstr,
-									int numfks, int16 *pkattnum, int16 *fkattnum,
-									Oid *pfeqoperators, Oid *ppeqoperators, Oid *ffeqoperators,
-									int numfkdelsetcols, int16 *fkdelsetcols,
-									bool old_check_ok, LOCKMODE lockmode,
-									Oid parentInsTrigger, Oid parentUpdTrigger,
-									bool with_period);
-static void CloneForeignKeyConstraints(List **wqueue, Relation parentRel,
-									   Relation partitionRel);
-static void CloneFkReferenced(Relation parentRel, Relation partitionRel);
-static void CloneFkReferencing(List **wqueue, Relation parentRel,
-							   Relation partRel);
 static void createForeignKeyCheckTriggers(Oid myRelOid, Oid refRelOid,
 										  Constraint *fkconstraint, Oid constraintOid,
 										  Oid indexOid,
@@ -606,31 +439,6 @@ static void createForeignKeyActionTriggers(Oid myRelOid, Oid refRelOid,
 										   Oid indexOid,
 										   Oid parentDelTrigger, Oid parentUpdTrigger,
 										   Oid *deleteTrigOid, Oid *updateTrigOid);
-static bool tryAttachPartitionForeignKey(List **wqueue,
-										 ForeignKeyCacheInfo *fk,
-										 Relation partition,
-										 Oid parentConstrOid, int numfks,
-										 AttrNumber *mapped_conkey, AttrNumber *confkey,
-										 Oid *conpfeqop,
-										 Oid parentInsTrigger,
-										 Oid parentUpdTrigger,
-										 Relation trigrel);
-static void AttachPartitionForeignKey(List **wqueue, Relation partition,
-									  Oid partConstrOid, Oid parentConstrOid,
-									  Oid parentInsTrigger, Oid parentUpdTrigger,
-									  Relation trigrel);
-static void RemoveInheritedConstraint(Relation conrel, Relation trigrel,
-									  Oid conoid, Oid conrelid);
-static void DropForeignKeyConstraintTriggers(Relation trigrel, Oid conoid,
-											 Oid confrelid, Oid conrelid);
-static void GetForeignKeyActionTriggers(Relation trigrel,
-										Oid conoid, Oid confrelid, Oid conrelid,
-										Oid *deleteTriggerOid,
-										Oid *updateTriggerOid);
-static void GetForeignKeyCheckTriggers(Relation trigrel,
-									   Oid conoid, Oid confrelid, Oid conrelid,
-									   Oid *insertTriggerOid,
-									   Oid *updateTriggerOid);
 static void ATExecDropConstraint(Relation rel, const char *constrName,
 								 DropBehavior behavior, bool recurse,
 								 bool missing_ok, LOCKMODE lockmode);
@@ -707,45 +515,9 @@ static void RangeVarCallbackForDropRelation(const RangeVar *rel, Oid relOid,
 											Oid oldRelOid, void *arg);
 static void RangeVarCallbackForAlterRelation(const RangeVar *rv, Oid relid,
 											 Oid oldrelid, void *arg);
-static PartitionSpec *transformPartitionSpec(Relation rel, PartitionSpec *partspec);
-static void ComputePartitionAttrs(ParseState *pstate, Relation rel, List *partParams, AttrNumber *partattrs,
-								  List **partexprs, Oid *partopclass, Oid *partcollation,
-								  PartitionStrategy strategy);
-static void CreateInheritance(Relation child_rel, Relation parent_rel, bool ispartition);
-static void RemoveInheritance(Relation child_rel, Relation parent_rel,
-							  bool expect_detached);
-static ObjectAddress ATExecAttachPartition(List **wqueue, Relation rel,
-										   PartitionCmd *cmd,
-										   AlterTableUtilityContext *context);
-static void AttachPartitionEnsureIndexes(List **wqueue, Relation rel, Relation attachrel);
-static void QueuePartitionConstraintValidation(List **wqueue, Relation scanrel,
-											   List *partConstraint,
-											   bool validate_default);
-static void CloneRowTriggersToPartition(Relation parent, Relation partition);
-static void DropClonedTriggersFromPartition(Oid partitionId);
-static ObjectAddress ATExecDetachPartition(List **wqueue, AlteredTableInfo *tab,
-										   Relation rel, RangeVar *name,
-										   bool concurrent);
-static void DetachPartitionFinalize(Relation rel, Relation partRel,
-									bool concurrent, Oid defaultPartOid);
-static ObjectAddress ATExecDetachPartitionFinalize(Relation rel, RangeVar *name);
-static ObjectAddress ATExecAttachPartitionIdx(List **wqueue, Relation parentIdx,
-											  RangeVar *name);
-static void validatePartitionedIndex(Relation partedIdx, Relation partedTbl);
-static void refuseDupeIndexAttach(Relation parentIdx, Relation partIdx,
-								  Relation partitionTbl);
-static void verifyPartitionIndexNotNull(IndexInfo *iinfo, Relation partition);
-static List *GetParentedForeignKeyRefs(Relation partition);
-static void ATDetachCheckNoForeignKeyRefs(Relation partition);
 static char GetAttributeCompression(Oid atttypid, const char *compression);
 static char GetAttributeStorage(Oid atttypid, const char *storagemode);
 
-static void ATExecMergePartitions(List **wqueue, AlteredTableInfo *tab, Relation rel,
-								  PartitionCmd *cmd, AlterTableUtilityContext *context);
-static void ATExecSplitPartition(List **wqueue, AlteredTableInfo *tab,
-								 Relation rel, PartitionCmd *cmd,
-								 AlterTableUtilityContext *context);
-
 /* ----------------------------------------------------------------
  *		DefineRelation
  *				Creates a new relation.
@@ -4443,7 +4215,7 @@ CheckTableNotInUse(Relation rel, const char *stmt)
  * that, notably DROP TABLE.  (We must allow DROP or we couldn't clean out
  * an orphaned temp schema.)  Compare truncate_check_activity().
  */
-static void
+void
 CheckAlterTableIsSafe(Relation rel)
 {
 	/*
@@ -6583,7 +6355,7 @@ ATRewriteTable(AlteredTableInfo *tab, Oid OIDNewHeap)
 /*
  * ATGetQueueEntry: find or create an entry in the ALTER TABLE work queue
  */
-static AlteredTableInfo *
+AlteredTableInfo *
 ATGetQueueEntry(List **wqueue, Relation rel)
 {
 	Oid			relid = RelationGetRelid(rel);
@@ -6764,7 +6536,7 @@ alter_table_type_to_string(AlterTableType cmdtype)
  * - Ensure this user is the owner
  * - Ensure that it is not a system table
  */
-static void
+void
 ATSimplePermissions(AlterTableType cmdtype, Relation rel, int allowed_targets)
 {
 	int			actual_target;
@@ -6879,36 +6651,6 @@ ATSimpleRecursion(List **wqueue, Relation rel,
 	}
 }
 
-/*
- * Obtain list of partitions of the given table, locking them all at the given
- * lockmode and ensuring that they all pass CheckAlterTableIsSafe.
- *
- * This function is a no-op if the given relation is not a partitioned table;
- * in particular, nothing is done if it's a legacy inheritance parent.
- */
-static void
-ATCheckPartitionsNotInUse(Relation rel, LOCKMODE lockmode)
-{
-	if (rel->rd_rel->relkind == RELKIND_PARTITIONED_TABLE)
-	{
-		List	   *inh;
-		ListCell   *cell;
-
-		inh = find_all_inheritors(RelationGetRelid(rel), lockmode, NULL);
-		/* first element is the parent rel; must ignore it */
-		for_each_from(cell, inh, 1)
-		{
-			Relation	childrel;
-
-			/* find_all_inheritors already got lock */
-			childrel = table_open(lfirst_oid(cell), NoLock);
-			CheckAlterTableIsSafe(childrel);
-			table_close(childrel, NoLock);
-		}
-		list_free(inh);
-	}
-}
-
 /*
  * ATTypedTableRecursion
  *
@@ -8513,7 +8255,7 @@ ATExecSetIdentity(Relation rel, const char *colName, Node *def,
  *
  * Return the address of the affected column.
  */
-static ObjectAddress
+ObjectAddress
 ATExecDropIdentity(Relation rel, const char *colName, bool missing_ok, LOCKMODE lockmode,
 				   bool recurse, bool recursing)
 {
@@ -10748,7 +10490,7 @@ validateFkOnDeleteSetColumns(int numfks, const int16 *fkattnums,
  *      NULL/DEFAULT clause
  * with_period: true if this is a temporal FK
  */
-static ObjectAddress
+ObjectAddress
 addFkConstraint(addFkConstraintSides fkside,
 				char *constraintname, Constraint *fkconstraint,
 				Relation rel, Relation pkrel, Oid indexOid, Oid parentConstr,
@@ -10926,7 +10668,7 @@ addFkConstraint(addFkConstraintSides fkside,
  *      UPDATE respectively.
  * with_period: true if this is a temporal FK
  */
-static void
+void
 addFkRecurseReferenced(Constraint *fkconstraint, Relation rel,
 					   Relation pkrel, Oid indexOid, Oid parentConstr,
 					   int numfks,
@@ -11064,7 +10806,7 @@ addFkRecurseReferenced(Constraint *fkconstraint, Relation rel,
  *      UPDATE respectively.
  * with_period: true if this is a temporal FK
  */
-static void
+void
 addFkRecurseReferencing(List **wqueue, Constraint *fkconstraint, Relation rel,
 						Relation pkrel, Oid indexOid, Oid parentConstr,
 						int numfks, int16 *pkattnum, int16 *fkattnum,
